Core - Feature # 25397

Status: Closed Priority: Should have
Author: Dominique Feyer Category:

Created: 2011-03-25 Assigned To:

Updated: 2013-06-01 Due date:

PHP Version: 5.3

Complexity:

Sprint Focus:

Subject: Adding XLIFF support as the default format for translation

Description

The goal of the project is to extend TYPOS3 translation format support with XLIFF format.

This move is motivated by the lack of good tools to translate TYPO3. Translation team need advanced feature to manage their
workload and improve TYPO3 translation quality. Actually we are impressed by the features of Pootle (use by LibreOffice, Mozilla,
Gnome, ...) and plan to use it as a replacement of lixmltranslate.

We are actually working in the TYPO3 core, on github. The current job is to move the existing feature to dedicated class (parsing
lIxml, liphp, ...) and adding a sort of factory to switch between the correct parser.
https://github.com/dfeyer/git.typo3.org

You can check our test Pootle server here:
https://pootle.reelpeek.net/pootle/

And a quick and dirty tools to convert core lixml to XLIFF:
https://github.com/dfeyer/lixmi2xIiff

(issue imported from #M18040)

Subtasks:

Task # 27673: Add Parser for PHP locallang array Closed
Bug # 27923: locallangXMLOverride hook has been removed Closed
Bug # 28264: Wrong check for existance of translated label Closed

Related issues:

related to Core - Task # 28277: Add XLIFF files Closed 2011-07-17
related to Core - Bug # 27928: htmlArea RTE: Localization is broken in master Resolved 2011-07-07
related to Core - Bug # 28086: Disable clear lang cache by default Closed 2011-07-11
related to Core - Bug # 27972: LLXML Parser does not support localized label ... Closed 2011-07-08

Associated revisions

Revision cb390c79 - 2011-06-14 15:49 - Xavier Perseguers

[FEATURE] Add XLIFF translation support (110n)

Add a parser to support XLIFF + LLXML file as localization file format.

This patch includes:

- A parser factory to support multiple internationalization formats

(actually LLXML and XLIFF, parser for PHP array is not implemented,
yet). New parsers can be added in the future.
- A new parser for XLIFF (supporting plurals, based on the parser of
FLOWS)
Autoload for sysext 'lang’

Update the existing localization method (FE, BE, Extbase) to support
the new format of the LOCAL_LANG array
New caching class based on the caching framework or file based

Autodetection igbinary for cache un/serialization
- htmlArea RTE: update of the localization API

Currently the localization method works as before (only key-based

localization).

More functionality will be implemented in the new localization API
(plurals, ...). The current parser can be used on a TYPO3 instance with
LLXML and/or XLIFF files. However if an extension uses XLIFF, the
language pack (typo3conf/I10n) MUST use the same format.

The parser and the format priority (by default: xIf, xml, php), can be
configured in $TYPO3_CONF_VARS['SYS']['lang.

Change-Id: 184d0a463f1b5448b4bca3f7d200315f397f4eal8
Resolves: #25397
Reviewed-on: http://review.typo3.org/2572

Reviewed-by: Oliver Hader
Tested-by: Oliver Hader
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

Revision 70adc0a4 - 2011-07-09 20:28 - Dominique Feyer

[FEATURE] New caching framework implementation for 110n

Add custom caching table for parsed 110n file.

Change-Id: 1a59a77757112bccbf7a53ebeec71928f06ebe02a

Resolves: #25397
Reviewed-on: http://review.typo3.0rg/2930

Reviewed-by: Stefan Neufeind
Reviewed-by: Bjérn Pedersen
Tested-by: Bjorn Pedersen
Reviewed-by: Peter Beernink
Tested-by: Peter Beernink
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

Revision b48bfc9c - 2013-02-14 15:15 - Daniel Alder

[BUGFIX] Allow "en" as language key

Fix a bug which was introduced by #25397 (commit:cb390c79).
If the selected language key is "en", do not override it to "default".
This allows custom updates to translations even for the English language.

Change-Id: 13fcbd35f0144a0cc152acd45d0861d153cc8b495
Resolves: #42084

Related: #25397

Releases: 4.6, 4.7, 6.0, 6.1

Reviewed-on: https://review.typo3.org/17414

Reviewed-by: Oliver Hader
Tested-by: Oliver Hader
Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

Revision 8df3441a - 2013-02-14 15:22 - Daniel Alder

[BUGFIX] Allow "en" as language key

Fix a bug which was introduced by #25397 (commit:cb390c79).

If the selected language key is "en", do not override it to "default".

This allows custom updates to translations even for the English language.

Change-Id: 13fcbd35f0144a0cc152acd45d0861d153cc8b495
Resolves: #42084

Related: #25397

Releases: 4.6, 4.7, 6.0, 6.1

Reviewed-on: https://review.typo3.org/17414

Reviewed-by: Oliver Hader

Tested-by: Oliver Hader

Reviewed-by: Xavier Perseguers

Tested-by: Xavier Perseguers

Reviewed-on: https://review.typo3.org/18262

Revision 915bf762 - 2013-02-14 15:38 - Xavier Perseguers

[BUGFIX] Allow "en" as language key

Fix a bug which was introduced by #25397 (commit:cb390c79).
If the selected language key is "en", do not override it to "default".

This allows custom updates to translations even for the English language.

Change-Id: 13fcbd35f0144a0cc152acd45d0861d153cc8b495
Resolves: #42084

Related: #25397

Releases: 4.6, 4.7, 6.0, 6.1

Reviewed-on: https://review.typo3.org/18263

Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

Revision 2c4bffaa - 2013-02-14 15:38 - Xavier Perseguers

[BUGFIX] Allow "en" as language key

2015-08-04

3/6


https://review.typo3.org/17414
https://review.typo3.org/17414
https://review.typo3.org/18262
https://review.typo3.org/18263

Fix a bug which was introduced by #25397 (commit:cb390c79).
If the selected language key is "en", do not override it to "default".
This allows custom updates to translations even for the English language.

Change-Id: I3fcbd35f0144a0cc152acd45d0861d153cc8b495
Resolves: #42084

Related: #25397

Releases: 4.6, 4.7, 6.0, 6.1

Reviewed-on: https://review.typo3.org/18264

Reviewed-by: Xavier Perseguers
Tested-by: Xavier Perseguers

History

#1 - 2011-03-29 10:06 - Karsten Dambekalns
- Has patch set to No

- Patch is reviewed set to No

Just chiming in to say this has full support from the Phoenix and FLOW team, as we use XLIFF as default format as well, and Pootle was the

translation server of choice as well. :)

#2 - 2011-06-07 23:09 - Dominique Feyer
- File I10n.tar.gz added

| just attach some XLIFF file to test the parser. The language pack contain LLXML + XLIFF

#3 - 2011-06-09 21:38 - Steffen Gebert

Hints for reviewing the changes by Dominique:

First public version of the parser to support XLIFF + LLXML file as localization file format.

This patch includes:

- A parser factory to support multiple internationalization formats (actually LLXML and XLIFF,
parser for PHP array is not implemented yet). New parsers can be added in the future.

- A new parser for XLIFF (supporting plurals, based on the parser of FLOW3)

- Autoload for sysext 'lang'

- Update the existing localization method (FE, BE, Extbase) to support the new format

of the LOCAL_LANG array

- New caching class based on the caching framework or file based

- Autodetection igbinary for cache un/serialization

- htmlArea RTE: update of the localization API

Currently the localization method works as before (only key-based localization).
More functionality will be implemented in the new localization API (plurals, ...). The current

parser can be used on a TYPOS instance with LLXML and/or XLIFF files. However if an extension
uses XLIFF, the language pack (typo3conf/[10n) MUST use the same format.
The parser and the format priority (by default: xIf, xml, php), can be configured in:
$TYPO3_CONF_VARS['SYST 'lang]

Beware: This patch breaks internationalization of many ExtJS based extension (like extension
manager, workspace, recycler). This bug shows "Object" as label. Another patch will be pushed
with a new ExtJS API to handle it, and extension update will be needed to fix this breaking

change.

If you see "Object" as label in rtehtmlarea, please clear the cache of the RTE and reload
your backend.

#4 - 2011-06-09 21:42 - Mr. Hudson

Patch set 5 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.
It is available at http://review.typo3.org/2572

#5 - 2011-06-10 14:40 - Xavier Perseguers
- Status changed from New to Accepted
- PHP Version set to 5.3

#6 - 2011-06-10 21:33 - Mr. Hudson

Patch set 6 of change 184d0a463f1b5448b4bca3f7d200315f{397f4ea18 has been pushed to the review server.
It is available at http://review.typo3.org/2572

#7 - 2011-06-13 10:09 - Mr. Hudson

Patch set 7 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.
It is available at http://review.typo3.org/2572

#8 - 2011-06-13 13:54 - Mr. Hudson

Patch set 8 of change 184d0a463f1b5448b4bca3f7d200315f397f4eal18 has been pushed to the review server.
It is available at http://review.typo3.org/2572

#9 - 2011-06-13 21:55 - Mr. Hudson

Patch set 10 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.
It is available at http://review.typo3.org/2572

#10 - 2011-06-13 23:47 - Mr. Hudson

Patch set 11 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.

2015-08-04 5/6


http://review.typo3.org/2572
http://review.typo3.org/2572
http://review.typo3.org/2572
http://review.typo3.org/2572
http://review.typo3.org/2572

It is available at http://review.typo3.org/2572

#11 - 2011-06-13 23:50 - Mr. Hudson

Patch set 12 of change 184d0a463f1b5448b4bca3f7d200315f397f4eal18 has been pushed to the review server.

It is available at http://review.typo3.org/2572

#12 - 2011-06-14 11:38 - Mr. Hudson

Patch set 13 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.

It is available at http://review.typo3.org/2572

#13 - 2011-06-14 12:09 - Mr. Hudson

Patch set 14 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.

It is available at http://review.typo3.org/2572

#14 - 2011-06-14 14:55 - Mr. Hudson

Patch set 15 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.

It is available at http://review.typo3.org/2572

#15 - 2011-06-14 15:08 - Mr. Hudson

Patch set 16 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.

It is available at http://review.typo3.org/2572

#16 - 2011-06-14 15:20 - Mr. Hudson

Patch set 17 of change 184d0a463f1b5448b4bca3f7d200315f397f4ea18 has been pushed to the review server.

It is available at http://review.typo3.org/2572

#17 - 2011-06-14 15:54 - Xavier Perseguers

- Status changed from Accepted to Resolved

- Target version changed from 4.6.0-betat to 1238
- % Done changed from 0 to 100

#18 - 2012-03-07 13:31 - Xavier Perseguers
- Status changed from Resolved to Closed

#19 - 2013-06-01 14:43 - Ernesto Baschny
- Target version deleted (1238)

Files

[10n.tar.gz 15.6 MB 2011-06-07
